/*
 *	Mouse support.
 */

#include <stdlib.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <unistd.h>

#include "hr_defines.h"
#include "hr_bitmaps.h"
#include "hr_bobs.h"
#include "hr_general.h"
#include "hr_gif.h"


struct {
	int   flags;
	int   button;
	int   x;
	int   y;
	struct hr_bob *bob;
} hr_mouse;



/* Initializes mouse.*/
void hr_init_mouse()
{
	unsigned char tmp[HR_BUFFER_SIZE];
	struct hr_bitmap *ptrbmap;
	sprintf(tmp,"%s%s",hr.datapath,PTRBITMAP);
	hr_mouse.flags=MOUSE_STAYS_ON_TOP;
	if((ptrbmap=hr_read_gif(tmp,GFX_COLOR))){
		hr_mouse.bob=hr_create_bob(ptrbmap,0,0,GFX_COLOR);
		hr_recolor_bitmap(hr_mouse.bob->bitmap,11,NONE);
		hr_mouse.bob->x=hr_mouse.x;
		hr_mouse.bob->y=hr_mouse.y;
	}
#if 0
	else
	  printf("Error reading %s\n",tmp);
#endif
}


/* This updates the stuff in mouse structure
 * and inits/draws/removes pointer.*/
void hr_update_mouse(int flags,int mode)
{
	/* Get new mouse event ---------------------------------------------*/
#if 0
	if(flags & WAIT_EVENT)
	  mouse_waitforupdate();
	else
#endif
	  mouse_update();
	/* Update mouse structure data -------------------------------------*/
	hr_mouse.x=mouse_getx();
	hr_mouse.y=mouse_gety();
	hr_mouse.button=mouse_getbutton();
	/* Update pointer --------------------------------------------------*/
	hr_update_bob(hr_mouse.bob,hr_mouse.x,hr_mouse.y,NULL,mode);
}
